<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Maintain_Asset_Shares_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: Root element for the Request for Put Asset Shares
 * @subpackage Structs
 */
class Maintain_Asset_Shares_RequestType extends AbstractStructBase
{
    /**
     * The Put_Asset_Shares_Data
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Asset_Share_DataType
     */
    public $Put_Asset_Shares_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Maintain_Asset_Shares_RequestType
     * @uses Maintain_Asset_Shares_RequestType::setPut_Asset_Shares_Data()
     * @uses Maintain_Asset_Shares_RequestType::setVersion()
     * @param \StructType\Asset_Share_DataType $put_Asset_Shares_Data
     * @param string $version
     */
    public function __construct(\StructType\Asset_Share_DataType $put_Asset_Shares_Data = null, $version = null)
    {
        $this
            ->setPut_Asset_Shares_Data($put_Asset_Shares_Data)
            ->setVersion($version);
    }
    /**
     * Get Put_Asset_Shares_Data value
     * @return \StructType\Asset_Share_DataType|null
     */
    public function getPut_Asset_Shares_Data()
    {
        return $this->Put_Asset_Shares_Data;
    }
    /**
     * Set Put_Asset_Shares_Data value
     * @param \StructType\Asset_Share_DataType $put_Asset_Shares_Data
     * @return \StructType\Maintain_Asset_Shares_RequestType
     */
    public function setPut_Asset_Shares_Data(\StructType\Asset_Share_DataType $put_Asset_Shares_Data = null)
    {
        $this->Put_Asset_Shares_Data = $put_Asset_Shares_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Maintain_Asset_Shares_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
